# user.query

Query users with query-filters and query-options.

If users provided by Active Directory or LDAP are not desired, then “local”, “=”, True should be added to filters.

Type: object

##

Type: array
No Additional Items

#### Tuple Validation

##### Parameter 1: filters

#### filters

Type: array Default: []
No Additional Items

##### Each item of this array must be:

Type: object

##### Parameter 2: options

#### options

Type: object
Default:
{ "relationships": true, "extend": null, "extend_context": null, "prefix": null, "extra": {}, "order_by": [], "select": [], "count": false, "get": false, "offset": 0, "limit": 0, "force_sql_filters": false }
No Additional Properties

##

#### Relationships

Type: boolean Default: true

##

#### Extend

Default: null

## Any of

Type: string
Type: null

##

#### Extend Context

Default: null

## Any of

Type: string
Type: null

##

#### Prefix

Default: null

## Any of

Type: string
Type: null

##

#### Extra

Type: object Default: {}

##

#### Order By

Type: array of string Default: []
No Additional Items

##### Each item of this array must be:

Type: string

##

#### Select

Type: array Default: []
No Additional Items

##### Each item of this array must be:

## Any of

Type: string
Type: array
No Additional Items

##### Each item of this array must be:

Type: object

##

#### Count

Type: boolean Default: false

##

#### Get

Type: boolean Default: false

##

#### Offset

Type: integer Default: 0

##

#### Limit

Type: integer Default: 0

##

#### Force Sql Filters

Type: boolean Default: false

##

#### Result

## Any of

Type: array of object
No Additional Items

##### Each item of this array must be:

#### UserQueryResultItem

Type: object
No Additional Properties

##

#### Id

Type: integer

##

#### Uid

Type: integer

##

#### Username

## Any of

Type: string
Type: string

Must be at least `1` characters long

##

#### Unixhash

## Any of

Type: string
Type: null

##

#### Smbhash

## Any of

Type: string
Type: null

##

#### Home

Type: string

Must be at least `1` characters long

##

#### Shell

Type: string

Available choices can be retrieved with `user.shell_choices`.

Must be at least `1` characters long

##

#### Full Name

Type: string

##

#### Builtin

Type: boolean

##

#### Smb

Type: boolean

##

#### Userns Idmap

Species the subuid mapping for this user. If DIRECT then the UID will be
directly mapped to all containers. Alternatively, the target UID may be
explicitly specified. If None, then the UID will not be mapped.

NOTE: this field will be ignored for users that have been assigned
TrueNAS roles.

## Any of

Type: const
Specific value: `"DIRECT"`
Type: integer

Value must be greater or equal to `1` and lesser or equal to `4294967294`

Type: null

##

#### Group

Type: object

##

#### Groups

Type: array of integer

Specifies whether the user should be allowed access to SMB shares. User will also automatically be added to
the `builtin_users` group.

No Additional Items

##### Each item of this array must be:

Type: integer

##

#### Password Disabled

Type: boolean

##

#### Ssh Password Enabled

Type: boolean

Required if `password_disabled` is false.

##

#### Sshpubkey

## Any of

Type: string
Type: null

##

#### Locked

Type: boolean

##

#### Sudo Commands

Type: array of string
No Additional Items

##### Each item of this array must be:

Type: string

Must be at least `1` characters long

##

#### Sudo Commands Nopasswd

Type: array of string
No Additional Items

##### Each item of this array must be:

Type: string

Must be at least `1` characters long

##

#### Email

## Any of

Type: string Format: email
Type: null

##

#### Id Type Both

Type: boolean

##

#### Local

Type: boolean

##

#### Immutable

Type: boolean

##

#### Twofactor Auth Configured

Type: boolean

##

#### Sid

## Any of

Type: string
Type: null

##

#### Last Password Change

The date of the last password change for local user accounts.

## Any of

Type: string Format: date-time
Type: null

##

#### Password Age

The age in days of the password for local user accounts.

## Any of

Type: integer
Type: null

##

#### Password History

This contains hashes of the ten most recent passwords used by local user accounts, and is
for enforcing password history requirements as defined in system.security.

## Any of

Type: array
No Additional Items

##### Each item of this array must be:

Type: object
Type: null

##

#### Password Change Required

Type: boolean

Password change for local user account is required on next login.

##

#### Roles

Type: array of string
No Additional Items

##### Each item of this array must be:

Type: string

##

#### Api Keys

Type: array of integer
No Additional Items

##### Each item of this array must be:

Type: integer

#### UserQueryResultItem

Type: object
No Additional Properties

##

#### Id

Type: integer

##

#### Uid

Type: integer

##

#### Username

## Any of

Type: string
Type: string

Must be at least `1` characters long

##

#### Unixhash

## Any of

Type: string
Type: null

##

#### Smbhash

## Any of

Type: string
Type: null

##

#### Home

Type: string

Must be at least `1` characters long

##

#### Shell

Type: string

Available choices can be retrieved with `user.shell_choices`.

Must be at least `1` characters long

##

#### Full Name

Type: string

##

#### Builtin

Type: boolean

##

#### Smb

Type: boolean

##

#### Userns Idmap

Species the subuid mapping for this user. If DIRECT then the UID will be
directly mapped to all containers. Alternatively, the target UID may be
explicitly specified. If None, then the UID will not be mapped.

NOTE: this field will be ignored for users that have been assigned
TrueNAS roles.

## Any of

Type: const
Specific value: `"DIRECT"`
Type: integer

Value must be greater or equal to `1` and lesser or equal to `4294967294`

Type: null

##

#### Group

Type: object

##

#### Groups

Type: array of integer

Specifies whether the user should be allowed access to SMB shares. User will also automatically be added to
the `builtin_users` group.

No Additional Items

##### Each item of this array must be:

Type: integer

##

#### Password Disabled

Type: boolean

##

#### Ssh Password Enabled

Type: boolean

Required if `password_disabled` is false.

##

#### Sshpubkey

## Any of

Type: string
Type: null

##

#### Locked

Type: boolean

##

#### Sudo Commands

Type: array of string
No Additional Items

##### Each item of this array must be:

Type: string

Must be at least `1` characters long

##

#### Sudo Commands Nopasswd

Type: array of string
No Additional Items

##### Each item of this array must be:

Type: string

Must be at least `1` characters long

##

#### Email

## Any of

Type: string Format: email
Type: null

##

#### Id Type Both

Type: boolean

##

#### Local

Type: boolean

##

#### Immutable

Type: boolean

##

#### Twofactor Auth Configured

Type: boolean

##

#### Sid

## Any of

Type: string
Type: null

##

#### Last Password Change

The date of the last password change for local user accounts.

## Any of

Type: string Format: date-time
Type: null

##

#### Password Age

The age in days of the password for local user accounts.

## Any of

Type: integer
Type: null

##

#### Password History

This contains hashes of the ten most recent passwords used by local user accounts, and is
for enforcing password history requirements as defined in system.security.

## Any of

Type: array
No Additional Items

##### Each item of this array must be:

Type: object
Type: null

##

#### Password Change Required

Type: boolean

Password change for local user account is required on next login.

##

#### Roles

Type: array of string
No Additional Items

##### Each item of this array must be:

Type: string

##

#### Api Keys

Type: array of integer
No Additional Items

##### Each item of this array must be:

Type: integer
Type: integer

Required roles: ACCOUNT_READ